/*

  Connections:
      Encoder    Arduino
      A          D3
      B          D2
      C          GND
 */
#include <LiquidCrystal_I2C.h>
#include <Encoder.h>
#include <Wire.h>  
// Initialise the encoder on digital pins 2 & 3
LiquidCrystal_I2C lcd(0x3F,20,4);
Encoder encoder(3, 2);
Encoder encoder2(5, 4);
long oldPos  = -999;
long oldPos2  = -999;
long newPos = 0;
long newPos2 = 0;
// Initial frequency
long frequency =100000000;
long volume = 30;
long band = 100000000;
int tune = 1000;
int tunex = 1;
int mod = 6;
int sttep =1;
int sery=0;  


void setup() {
pinMode(6, INPUT_PULLUP);
pinMode(7, INPUT_PULLUP);
pinMode(8, INPUT_PULLUP);
pinMode(9, INPUT_PULLUP);
pinMode(10, INPUT_PULLUP);
pinMode(11, INPUT_PULLUP);
pinMode(12,  INPUT_PULLUP);
pinMode(13,  INPUT_PULLUP);
Serial.begin(115200);
//Serial.println("{\"Command\":\"Exe\",\"Method\":\"Start\"}"); // play
delay(1000);
displayr();
}

void loop() {
  // Get the encoder position
int  buttonState6 = digitalRead(6);
int  buttonState7 = digitalRead(7);
int  buttonState8 = digitalRead(8);
int  buttonState9 = digitalRead(9);
int  buttonState10 = digitalRead(10);
int  buttonState11 = digitalRead(11);
int  buttonState12 = digitalRead(12);
int  buttonState13 = digitalRead(13);

 if (Serial.available()) {
   Serial.read();
if (sery<=2) {    
//Serial.println("{\"Command\":\"Exe\",\"Method\":\"Start\"}");
//delay(1000);
sery=sery+1;
delay(1000);
Serial.print("{\"Command\": \"Set\", \"Method\": \"Frequency\", \"Value\": ");
Serial.print(frequency +(newPos * tune));
Serial.println("}\r\n");
};
if (sery>=1000){sery=100;};

 };
    if (buttonState6 == HIGH) {
delay(100);
 sttep = sttep + 1;


if (sttep == 8) {
sttep = 1;
tune=1000;
};
if (sttep==1){
tune=1000;
};
if (sttep==2){
tune=10000;
};
if (sttep==3){
tune=100000;
};
if (sttep==4){
tune=1000000;
};
if (sttep==5){
tune=1;
};

if (sttep==6){
tune=10;
};

if (sttep==7){
tune=100;
};
displayr();
};

    if (buttonState7 == HIGH) {
encoder2.write(0);
 newPos2=-999;
 oldPos2=-999;
 volume=10;
 delay(30); 
};

    if (buttonState8 == HIGH) {
delay(300);
 frequency= 27000000;
oldPos = -999;
newPos = -999;
encoder.write(0);
displayr();
};

    if (buttonState9 == HIGH) {
delay(30);
 frequency= 100000000;
oldPos = -999;
newPos = -999;
encoder.write(0);
displayr();
};
 
    if (buttonState10 == HIGH) {
delay(30);
  frequency= 145000000;
 oldPos = -999;
newPos = -999;
encoder.write(0);
displayr();
}; 
 
     if (buttonState11 == HIGH) {
delay(30);
  frequency= 433000000;
  oldPos = -999;
newPos = -999;
encoder.write(0);
displayr(); 
};
 
     if (buttonState12 == HIGH) {
delay(30);
   frequency= 446000000;
  oldPos = -999;
newPos = -999;
encoder.write(0);
displayr();
};

    if (buttonState13 == HIGH) {
delay(30);
 mod=mod+1;
  if (mod>=9){
  mod=1;};
 displayr();
};
 
  newPos = encoder.read();
  newPos2 = encoder2.read();
  if (newPos != oldPos) {
    oldPos = newPos;
    // Send the command to change the frequency via the serial port
   // Serial.println("{\"Command\": \"Set\", \"Method\": \"Frequency\", \"Value\": "frequency + (newPos * 1000)"}");
    Serial.print("{\"Command\": \"Set\", \"Method\": \"Frequency\", \"Value\": ");
    Serial.print(frequency +(newPos * tune));
    Serial.println("}\r\n");
    band=frequency +(newPos * tune);
    delay(100);

  };
  
    if (newPos2 != oldPos2) {
    oldPos2 = newPos2; 
 int volun = volume + newPos2;
  if (volun <= 60) {
    if (volun >=25) {
    Serial.print("{\"Command\": \"Set\", \"Method\": \"AudioGain\", \"Value\": ");
   Serial.print(volume +(newPos2 +1));
    Serial.println("}\r\n");
    delay(100);
} ;
    
  } else {
 encoder2.write(0);
 volun=0;
 newPos2=-999;
 oldPos2=-999;
 volume=10;
  };
  
  
  
  };
  
  
  
  delay(50);
}


void displayr () {
//---------Вывод на дисплей------------------------------ 
  lcd.init();
  lcd.backlight();
  lcd.setCursor(4, 0);
  lcd.print("SDR RECEIVER");
  lcd.setCursor(0, 1);
  lcd.print("BAND=");
  lcd.setCursor(5, 1);
  lcd.print(frequency / 1000000);
  lcd.setCursor(10, 1);
  lcd.print("MHz.");
  
  lcd.setCursor(0, 2);
  lcd.print("MOD =");
  lcd.setCursor(6, 2);
  if (mod==1){
  lcd.print("AM");
  Serial.print("{\"Command\": \"Set\", \"Method\": \"DetectorType\", \"Value\":"); 
  Serial.print("\"AM\""); 
  Serial.println("}\r\n"); 
  delay(50);
  };
  if (mod==2){
  lcd.print("CW");
  Serial.print("{\"Command\": \"Set\", \"Method\": \"DetectorType\", \"Value\":"); 
  Serial.print("\"CW\"");  
  Serial.println("}\r\n"); 
  delay(50);
  };
  if (mod==3){
  lcd.print("DSB");
   Serial.print("{\"Command\": \"Set\", \"Method\": \"DetectorType\", \"Value\":");  
  Serial.print("\"DSB\""); 
  Serial.println("}\r\n"); 
  delay(50);
  };
  if (mod==4){
  lcd.print("LSB");
   Serial.print("{\"Command\": \"Set\", \"Method\": \"DetectorType\", \"Value\":");  
  Serial.print("\"LSB\""); 
  Serial.println("}\r\n"); 
  delay(50);
  };
  if (mod==5){
  lcd.print("NFM");
   Serial.print("{\"Command\": \"Set\", \"Method\": \"DetectorType\", \"Value\":"); 
  Serial.print("\"NFM\""); 
  Serial.println("}\r\n"); 
  delay(50);
  };
  if (mod==6){
  lcd.print("WFM");
   Serial.print("{\"Command\": \"Set\", \"Method\": \"DetectorType\", \"Value\":"); 
  Serial.print("\"WFM\""); 
  Serial.println("}\r\n"); 
  delay(50);
  };
    if (mod==7){
  lcd.print("USB");
   Serial.print("{\"Command\": \"Set\", \"Method\": \"DetectorType\", \"Value\":");  
  Serial.print("\"USB\""); 
  Serial.println("}\r\n"); 
  delay(50);
  };
    if (mod==8){
  lcd.print("RAW");
   Serial.print("{\"Command\": \"Set\", \"Method\": \"DetectorType\", \"Value\":"); 
  Serial.print("\"RAW\""); 
  Serial.println("}\r\n"); 
  delay(50);
  };

  
  lcd.setCursor(0, 3);
  lcd.print("STEP=");
  lcd.setCursor(6, 3);
  
  if (sttep==1) {
  lcd.print(1);
  lcd.setCursor(10, 3);
  lcd.print("KHz.");
  };
    if (sttep==2) {
  lcd.print(10);
  lcd.setCursor(10, 3);
  lcd.print("KHz.");
    };
    if (sttep==3) {
  lcd.print(100);
  lcd.setCursor(10, 3);
  lcd.print("KHz.");
    };
    if (sttep==4) {
  lcd.print(1);
  lcd.setCursor(10, 3);
  lcd.print("MHz.");
    };
    if (sttep==5) {
  lcd.print(1);
  lcd.setCursor(10, 3);
  lcd.print("Hz.");
    };
    if (sttep==6) {
  lcd.print(10);
  lcd.setCursor(10, 3);
  lcd.print("Hz.");
    };
    if (sttep==7){
  lcd.print(100);
  lcd.setCursor(10, 3);
  lcd.print("Hz.");
    };
  
 //------------------------------------ 

};

